(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations'), require('@angular/common'), require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@bravobit/bb-foundation', ['exports', '@angular/animations', '@angular/common', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (factory((global.bravobit = global.bravobit || {}, global.bravobit['bb-foundation'] = {}),global.ng.animations,global.ng.common,global.ng.core,global.rxjs,global.rxjs.operators));
}(this, (function (exports,animations,common,i0,rxjs,operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var hasV8BreakIterator = (typeof Intl !== 'undefined' && (( /** @type {?} */(Intl))).v8BreakIterator);
    var Platform = /** @class */ (function () {
        function Platform(_platformId) {
            this._platformId = _platformId;
        }
        Object.defineProperty(Platform.prototype, "isBrowser", {
            // Browser check.
            get: 
            // Browser check.
            /**
             * @return {?}
             */
            function () {
                return this._platformId
                    ? common.isPlatformBrowser(this._platformId)
                    : typeof document === 'object' && !!document;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isTrident", {
            // Rendering engines.
            get: 
            // Rendering engines.
            /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /(msie|trident)/i.test(navigator.userAgent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isBlink", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && (!!((( /** @type {?} */(window))).chrome || hasV8BreakIterator) &&
                    typeof CSS !== 'undefined' && !this.isEdge && !this.isTrident);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isWebkit", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /AppleWebKit/i.test(navigator.userAgent)
                    && !this.isBlink && !this.isEdge && !this.isTrident;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isChrome", {
            // Browsers.
            get: 
            // Browsers.
            /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /Google Inc./.test(navigator.vendor);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isEdge", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /(edge)/i.test(navigator.userAgent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isFirefox", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /(firefox|minefield)/i.test(navigator.userAgent);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isSafari", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /safari/i.test(navigator.userAgent) && this.isWebkit;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isIos", {
            // Platforms.
            get: 
            // Platforms.
            /**
             * @return {?}
             */
            function () {
                return this.isBrowser && /iPad|iPhone|iPod/.test(navigator.userAgent) && !('MSStream' in window);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Platform.prototype, "isAndroid", {
            get: /**
             * @return {?}
             */ function () {
                return this.isBrowser && /android/i.test(navigator.userAgent) && !this.isTrident;
            },
            enumerable: true,
            configurable: true
        });
        Platform.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        Platform.ctorParameters = function () {
            return [
                { type: Object, decorators: [{ type: i0.Optional }, { type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
            ];
        };
        /** @nocollapse */ Platform.ngInjectableDef = i0.defineInjectable({ factory: function Platform_Factory() { return new Platform(i0.inject(i0.PLATFORM_ID, 8)); }, token: Platform, providedIn: "root" });
        return Platform;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Language = /** @class */ (function () {
        function Language() {
            this.getLanguages = function () {
                if (typeof navigator !== 'object') {
                    return null;
                }
                /** @type {?} */
                var t = 'anguage';
                /** @type {?} */
                var n = navigator;
                /** @type {?} */
                var f = n['l' + t + 's'];
                /** @type {?} */
                var data = f && f.length ? f : (t = n['l' + t] ||
                    n['browserL' + t] ||
                    n['userL' + t]) ? [t] : t;
                return typeof data === 'string'
                    ? data
                    : data.join(';');
            };
        }
        Object.defineProperty(Language.prototype, "all", {
            get: /**
             * @return {?}
             */ function () {
                // Get the languages.
                /** @type {?} */
                var data = this.getLanguages();
                // Parse all languages by using a regex.
                /** @type {?} */
                var strings = (data || '')
                    .match(/((([a-zA-Z]+(-[a-zA-Z0-9]+){0,2})|\*)(;q=[0-1](\.[0-9]+)?)?)*/g);
                // Get the content by parsing the strings.
                /** @type {?} */
                var content = strings.map(function (item) {
                    if (!item) {
                        return null;
                    }
                    /** @type {?} */
                    var bits = item.split(';');
                    /** @type {?} */
                    var ietf = bits[0].split('-');
                    /** @type {?} */
                    var hasScript = ietf.length === 3;
                    return {
                        code: ietf[0],
                        script: hasScript ? ietf[1] : null,
                        region: hasScript ? ietf[2] : ietf[1],
                        quality: bits[1] ? parseFloat(bits[1].split('=')[1]) : 1.0
                    };
                });
                // Filter out all the empty items
                // and sort them by the quality.
                return content
                    .filter(function (item) { return !!item; })
                    .sort(function (a, b) { return b.quality - a.quality; });
            },
            enumerable: true,
            configurable: true
        });
        Language.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */ Language.ngInjectableDef = i0.defineInjectable({ factory: function Language_Factory() { return new Language(); }, token: Language, providedIn: "root" });
        return Language;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboard = /** @class */ (function () {
        function BbDashboard(_renderer) {
            this._renderer = _renderer;
            // Inputs.
            this.backgroundColor = '#d5dae6';
            this.maxWidth = '1200px';
            this.padding = '20px';
            // State.
            this.sidebarVisible$ = new rxjs.BehaviorSubject(true);
        }
        Object.defineProperty(BbDashboard.prototype, "visibility", {
            get: /**
             * @return {?}
             */ function () {
                return this.sidebarVisible$.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbDashboard.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                // Set the HTML class to prevent scrolling.
                return this.setHtmlClass();
            };
        /**
         * @return {?}
         */
        BbDashboard.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                // Remove the HTML class.
                return this.setHtmlClass(true);
            };
        /**
         * @return {?}
         */
        BbDashboard.prototype.toggleSidebarVisibility = /**
         * @return {?}
         */
            function () {
                // Get the previous value.
                /** @type {?} */
                var previousValue = this.sidebarVisible$.getValue();
                // Invert the value and set the visibility.
                this.setSidebarVisibility(!previousValue);
            };
        /**
         * @param {?} newValue
         * @return {?}
         */
        BbDashboard.prototype.setSidebarVisibility = /**
         * @param {?} newValue
         * @return {?}
         */
            function (newValue) {
                this.sidebarVisible$.next(newValue);
            };
        /**
         * @private
         * @param {?=} shouldRemove
         * @return {?}
         */
        BbDashboard.prototype.setHtmlClass = /**
         * @private
         * @param {?=} shouldRemove
         * @return {?}
         */
            function (shouldRemove) {
                if (shouldRemove === void 0) {
                    shouldRemove = false;
                }
                // Check if the document element is available.
                if (!document || !document.documentElement) {
                    return;
                }
                // Define the class name.
                /** @type {?} */
                var className = 'bb-dashboard-html';
                // Add or remove the class.
                return shouldRemove
                    ? this._renderer.removeClass(document.documentElement, className)
                    : this._renderer.addClass(document.documentElement, className);
            };
        BbDashboard.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-dashboard',
                        template: "<!--\r\n    The outlet for where the sidebar\r\n    will be placed (if provided).\r\n-->\r\n<ng-content select=\"bb-dashboard-sidebar\">\r\n</ng-content>\r\n\r\n<!--\r\n    The section containing the header\r\n    and the main content.\r\n-->\r\n<section class=\"bb-dashboard-section\">\r\n    <!--\r\n        The outlet for where the header\r\n        will be placed (if provided).\r\n    -->\r\n    <ng-content select=\"bb-dashboard-header\">\r\n    </ng-content>\r\n\r\n    <!--\r\n        The outlet of the content that\r\n        will be provided by the router.\r\n    -->\r\n    <main [style.background-color]=\"backgroundColor\"\r\n          [style.padding]=\"padding\"\r\n          class=\"bb-dashboard-scroll\">\r\n        <div [style.max-width]=\"maxWidth\"\r\n             class=\"bb-dashboard-container\">\r\n            <ng-content></ng-content>\r\n        </div>\r\n    </main>\r\n</section>\r\n\r\n<!--\r\n    The backdrop that will be visible when\r\n    the sidebar is opened (only on mobile).\r\n-->\r\n<div [class.bb-dashboard-backdrop--visible]=\"!(visibility | async)\"\r\n     (click)=\"toggleSidebarVisibility()\"\r\n     class=\"bb-dashboard-backdrop\">\r\n</div>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard'
                        },
                        styles: [".bb-dashboard{height:100vh;display:-ms-flexbox;display:flex;overflow:hidden;position:relative}.bb-dashboard-section{-ms-flex:1;flex:1;height:100vh;display:-ms-flexbox;display:flex;overflow-x:hidden;-ms-flex-direction:column;flex-direction:column}.bb-dashboard-scroll{-ms-flex:1;flex:1;overflow-x:hidden;overflow-y:scroll;-webkit-overflow-scrolling:touch}.bb-dashboard-container{width:100%;margin:0 auto}.bb-dashboard-backdrop{top:0;left:0;right:0;bottom:0;opacity:0;z-index:5;position:absolute;will-change:opacity;pointer-events:none;background-color:rgba(0,0,0,.5);transition:opacity .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-backdrop--visible{opacity:1;cursor:pointer;pointer-events:all}@media only screen and (min-width:768px){.bb-dashboard-backdrop{display:none}}.bb-dashboard-html{height:100%;overflow:hidden}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboard.ctorParameters = function () {
            return [
                { type: i0.Renderer2 }
            ];
        };
        BbDashboard.propDecorators = {
            backgroundColor: [{ type: i0.Input }],
            maxWidth: [{ type: i0.Input }],
            padding: [{ type: i0.Input }]
        };
        return BbDashboard;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboardHeader = /** @class */ (function () {
        function BbDashboardHeader(_parent) {
            this._parent = _parent;
        }
        Object.defineProperty(BbDashboardHeader.prototype, "isSidebarVisible", {
            get: /**
             * @return {?}
             */ function () {
                return this._parent
                    ? this._parent.visibility
                    : rxjs.of(false);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbDashboardHeader.prototype.onToggleSidebarClicked = /**
         * @return {?}
         */
            function () {
                // If the parent exists toggle the sidebar visibility.
                if (!this._parent) {
                    return;
                }
                this._parent.toggleSidebarVisibility();
            };
        BbDashboardHeader.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-dashboard-header',
                        template: "<!--\r\n    The button that toggles the sidebar.\r\n-->\r\n<button (click)=\"onToggleSidebarClicked()\"\r\n        [class.bb-dashboard-header-button--reversed]=\"isSidebarVisible | async\"\r\n        class=\"bb-dashboard-header-button\"\r\n        type=\"button\"\r\n        tabindex=\"0\"\r\n        role=\"switch\">\r\n    <svg xmlns=\"http://www.w3.org/2000/svg\"\r\n         viewBox=\"0 0 157 109\"\r\n         width=\"17\"\r\n         height=\"12\"\r\n         role=\"img\">\r\n        <title>\r\n            Toggle\r\n        </title>\r\n        <path fill=\"#fff\"\r\n              d=\"M82 42V11.2L30 54.5l52 43.3V67h75V42zM9.5 109h-2c-4.1 0-7.5-3.4-7.5-7.5v-94C0 3.4 3.4 0 7.5 0h2C13.6 0 17 3.4 17 7.5v94c0 4.1-3.4 7.5-7.5 7.5z\">\r\n        </path>\r\n    </svg>\r\n</button>\r\n\r\n<!--\r\n    The extra items of the header.\r\n-->\r\n<div class=\"bb-dashboard-header-items\">\r\n    <ng-content></ng-content>\r\n</div>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard-header'
                        },
                        styles: [".bb-dashboard-header{z-index:1;width:100%;color:#fff;height:50px;display:-ms-flexbox;display:flex;padding:0 8px;min-height:50px;-ms-flex-align:center;align-items:center;background-color:#3f51b5;border-bottom:1px solid #303f9f}.bb-dashboard-header-button{width:68px;height:34px;border-radius:4px;-ms-flex-align:center;align-items:center;display:-ms-inline-flexbox;display:inline-flex;-ms-flex-pack:center;justify-content:center;border:1px solid #283593;background-color:transparent}.bb-dashboard-header-button>svg{height:100%;-webkit-transform:none;-ms-transform:none;transform:none;transition:transform .2s cubic-bezier(0,0,.2,1);transition:transform .2s cubic-bezier(0,0,.2,1),-webkit-transform .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-header-button--reversed>svg{-webkit-transform:rotateY(180deg);transform:rotateY(180deg)}.bb-dashboard-header-button:hover{background-color:rgba(0,0,0,.04)}.bb-dashboard-header-button:active{background-color:rgba(0,0,0,.08)}.bb-dashboard-header-items{display:-ms-flexbox;display:flex;margin-left:auto;-ms-flex-align:center;align-items:center}.bb-dashboard-header-items>:not(:first-child){margin-left:8px}@media only screen and (min-width:768px){.bb-dashboard-header-button>svg{-webkit-transform:rotateY(180deg);transform:rotateY(180deg)}.bb-dashboard-header-button--reversed>svg{-webkit-transform:none;-ms-transform:none;transform:none}}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboardHeader.ctorParameters = function () {
            return [
                { type: BbDashboard, decorators: [{ type: i0.Optional }] }
            ];
        };
        return BbDashboardHeader;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboardSidebar = /** @class */ (function () {
        function BbDashboardSidebar(_platform, _parent) {
            var _this = this;
            this._platform = _platform;
            this._parent = _parent;
            // Bindings.
            this.visible = true;
            // State.
            this._state$ = new rxjs.BehaviorSubject([]);
            // Token.
            this._localStorageToken = 'bb-dashboard-sidebar-state';
            this.saveCache = function (data) {
                // Get the local storage.
                /** @type {?} */
                var localStorage = _this.getLocalStorage();
                // Check if the local storage exists.
                if (!localStorage) {
                    return;
                }
                // Set the cache in the local storage.
                try {
                    localStorage.setItem(_this._localStorageToken, JSON.stringify(data));
                }
                catch (error) {
                    console.log('Error setting local storage data.');
                }
            };
        }
        /**
         * @return {?}
         */
        BbDashboardSidebar.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // Retrieve and set the cache.
                this.setCache();
                // Get the visibility observable from the parent
                // if the parent exists.
                /** @type {?} */
                var observable$ = this._parent
                    ? this._parent.visibility
                    : rxjs.of(false);
                // Subscribe to get the state changes.
                this._subscription = observable$
                    .subscribe(function (value) { return _this.visible = value; });
            };
        /**
         * @return {?}
         */
        BbDashboardSidebar.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                // Unsubscribe to prevent memory leaks.
                this._subscription && this._subscription.unsubscribe();
            };
        /**
         * @param {?} id
         * @return {?}
         */
        BbDashboardSidebar.prototype.registerGroup = /**
         * @param {?} id
         * @return {?}
         */
            function (id) {
                // Get the current groups.
                /** @type {?} */
                var current = this._state$.getValue();
                // Check if the id is already inside the groups.
                if (current.findIndex(function (item) { return item.id === id; }) > -1) {
                    throw new Error('Group id was already defined; can only have distinct id\'s.');
                }
                // Check if the item is in the cache
                // and create a new entry.
                /** @type {?} */
                var cacheItem = this._cache.find(function (item) { return item.id === id; });
                /** @type {?} */
                var newEntry = {
                    id: id,
                    state: cacheItem ? cacheItem.state : 'opened'
                };
                // Push the new groups array.
                this._state$.next(__spread(current, [newEntry]));
                // Return the slice of the state that the group needs.
                return this._state$.pipe(operators.map(function (state) { return state.find(function (item) { return item.id === id; }); }), operators.map(function (group) { return group.state; }));
            };
        /**
         * @param {?} id
         * @return {?}
         */
        BbDashboardSidebar.prototype.unregisterGroup = /**
         * @param {?} id
         * @return {?}
         */
            function (id) {
                // Get the old groups.
                /** @type {?} */
                var oldValue = this._state$.getValue();
                // Calculate the new groups.
                /** @type {?} */
                var newValue = oldValue.filter(function (item) { return item.id !== id; });
                // Push the new groups array.
                this._state$.next(newValue);
            };
        /**
         * @param {?} id
         * @param {?} newState
         * @return {?}
         */
        BbDashboardSidebar.prototype.toggleGroup = /**
         * @param {?} id
         * @param {?} newState
         * @return {?}
         */
            function (id, newState) {
                // Get the old groups.
                /** @type {?} */
                var oldValue = this._state$.getValue();
                // Create the new groups.
                /** @type {?} */
                var newValue = oldValue.map(function (item) {
                    return item.id !== id
                        ? item
                        : { id: id, state: newState };
                });
                // Push the new groups array.
                this._state$.next(newValue);
                // Save in the cache.
                this.saveCache(newValue);
            };
        /**
         * @return {?}
         */
        BbDashboardSidebar.prototype.close = /**
         * @return {?}
         */
            function () {
                // Set the sidebar visibility to true, this means
                // that on mobile the sidebar will be closed.
                this._parent.setSidebarVisibility(true);
            };
        /**
         * @private
         * @return {?}
         */
        BbDashboardSidebar.prototype.getLocalStorage = /**
         * @private
         * @return {?}
         */
            function () {
                // Check if the current platform is a browser.
                if (!this._platform.isBrowser) {
                    return null;
                }
                // Check if the window and local storage exist.
                return window && window.localStorage
                    ? localStorage
                    : null;
            };
        /**
         * @private
         * @return {?}
         */
        BbDashboardSidebar.prototype.setCache = /**
         * @private
         * @return {?}
         */
            function () {
                // Get the local storage.
                /** @type {?} */
                var localStorage = this.getLocalStorage();
                // Check if the local storage exists.
                if (!localStorage) {
                    return;
                }
                // Retrieve the raw data from the storage.
                /** @type {?} */
                var rawData = localStorage.getItem(this._localStorageToken);
                // Try to parse the data.
                /** @type {?} */
                var parsedData = null;
                // Only parse the data when it is not null.
                if (rawData !== null) {
                    try {
                        parsedData = JSON.parse(rawData);
                    }
                    catch (error) {
                        console.log('Error parsing local storage data.');
                    }
                }
                // Set the cache to the parsed data.
                this._cache = parsedData || [];
            };
        BbDashboardSidebar.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-dashboard-sidebar',
                        template: "<!--\r\n    The header of the sidebar.\r\n-->\r\n<header class=\"bb-dashboard-sidebar-header\">\r\n    <ng-content>\r\n    </ng-content>\r\n</header>\r\n\r\n<!--\r\n    The scroll area that contains the\r\n    groups in the navigation.\r\n-->\r\n<div class=\"bb-dashboard-sidebar-scroll\">\r\n    <ng-content select=\"bb-dashboard-sidebar-group\"></ng-content>\r\n</div>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard-sidebar',
                            'role': 'navigation'
                        },
                        styles: [".bb-dashboard-sidebar{top:0;bottom:0;z-index:10;left:-256px;width:256px;height:100vh;display:block;position:fixed;min-width:256px;will-change:transform;-webkit-transform:translateX(256px);-ms-transform:translateX(256px);transform:translateX(256px);border-right:1px solid rgba(0,0,0,.4);transition:transform 250ms cubic-bezier(0,0,.2,1);transition:transform 250ms cubic-bezier(0,0,.2,1),-webkit-transform 250ms cubic-bezier(0,0,.2,1);background:linear-gradient(to bottom,#fff,#f2f2f2) #fff}.bb-dashboard-sidebar.visible{-webkit-transform:none;-ms-transform:none;transform:none}.bb-dashboard-sidebar-header{height:120px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;border-bottom:1px solid #d8d8d8;background-color:rgba(255,255,255,.5)}.bb-dashboard-sidebar-scroll{overflow:auto;height:calc(100vh - 120px)}@media only screen and (min-width:768px){.bb-dashboard-sidebar{left:0;z-index:auto;-webkit-transform:none;-ms-transform:none;transform:none;position:relative;margin-left:-256px;transition:margin-left 250ms cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar.visible{margin-left:0}}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboardSidebar.ctorParameters = function () {
            return [
                { type: Platform },
                { type: BbDashboard, decorators: [{ type: i0.Optional }, { type: i0.Host }] }
            ];
        };
        BbDashboardSidebar.propDecorators = {
            visible: [{ type: i0.HostBinding, args: ['class.visible',] }]
        };
        return BbDashboardSidebar;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboardSidebarGroup = /** @class */ (function () {
        function BbDashboardSidebarGroup(_parent) {
            this._parent = _parent;
            // Inputs.
            this.id = null;
            this.icon = null;
            this.title = null;
            // State.
            this.state = 'opened';
        }
        Object.defineProperty(BbDashboardSidebarGroup.prototype, "isExpanded", {
            // Host bindings.
            get: 
            // Host bindings.
            /**
             * @return {?}
             */
            function () {
                return this.state === 'opened';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbDashboardSidebarGroup.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // Check if the id and title have been supplied.
                if (!this.id || !this.title) {
                    throw new Error('Id and title are required.');
                }
                // Register the group at the parent and
                // retrieve the slice of the state.
                /** @type {?} */
                var observable$ = this._parent
                    ? this._parent.registerGroup(this.id)
                    : rxjs.of('opened');
                // Subscribe to the state.
                this._subscription = observable$
                    .subscribe(function (state) { return _this.state = state; });
            };
        /**
         * @return {?}
         */
        BbDashboardSidebarGroup.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                // Unsubscribe to prevent memory leaks.
                this._subscription && this._subscription.unsubscribe();
                // Unregister the group at the parent.
                this._parent && this._parent.unregisterGroup(this.id);
            };
        /**
         * @return {?}
         */
        BbDashboardSidebarGroup.prototype.onClick = /**
         * @return {?}
         */
            function () {
                // Change the state.
                /** @type {?} */
                var nextState = this.state === 'opened' ? 'closed' : 'opened';
                // Set the state of the sidebar.
                this._parent && this._parent.toggleGroup(this.id, nextState);
            };
        /**
         * @return {?}
         */
        BbDashboardSidebarGroup.prototype.onItemClicked = /**
         * @return {?}
         */
            function () {
                // Close the sidebar on the parent.
                this._parent && this._parent.close();
            };
        BbDashboardSidebarGroup.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-dashboard-sidebar-group',
                        template: "<!--\r\n    The wrapper that contains the title and icon.\r\n-->\r\n<button (click)=\"onClick()\"\r\n        class=\"bb-dashboard-sidebar-group-title\"\r\n        type=\"button\"\r\n        role=\"switch\">\r\n    <i *ngIf=\"icon\"\r\n       class=\"material-icons bb-dashboard-sidebar-group-icon\">\r\n        {{ icon }}\r\n    </i>\r\n    <span *ngIf=\"title\"\r\n          class=\"bb-dashboard-sidebar-group-text\">\r\n        {{ title }}\r\n    </span>\r\n    <span class=\"bb-dashboard-sidebar-group-toggle\">\r\n        <svg xmlns=\"http://www.w3.org/2000/svg\"\r\n             viewBox=\"0 0 157 109\"\r\n             width=\"16\"\r\n             height=\"16\"\r\n             role=\"img\">\r\n            <title>\r\n                Toggle\r\n            </title>\r\n            <path\r\n                d=\"M82 42V11.2L30 54.5l52 43.3V67h75V42zM9.5 109h-2c-4.1 0-7.5-3.4-7.5-7.5v-94C0 3.4 3.4 0 7.5 0h2C13.6 0 17 3.4 17 7.5v94c0 4.1-3.4 7.5-7.5 7.5z\">\r\n            </path>\r\n        </svg>\r\n    </span>\r\n</button>\r\n\r\n<!--\r\n    The sidebar items that contain the\r\n    links to navigate to other pages.\r\n-->\r\n<ng-content select=\"[bb-dashboard-sidebar-item]\">\r\n</ng-content>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard-sidebar-group',
                            'role': 'group'
                        },
                        styles: [".bb-dashboard-sidebar-group{color:#000;display:block;overflow:hidden;border-bottom:1px solid rgba(0,0,0,.1);transition:background-color .2s cubic-bezier(0,0,.2,1),padding-bottom .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-group.expanded{padding-bottom:20px;background-color:rgba(0,0,0,.04)}.bb-dashboard-sidebar-group.expanded .bb-dashboard-sidebar-group-title{color:#000}.bb-dashboard-sidebar-group.expanded .bb-dashboard-sidebar-item{opacity:1;height:32px;line-height:32px;padding:6px 16px 6px 54px}.bb-dashboard-sidebar-group.expanded .bb-dashboard-sidebar-group-toggle>svg{-webkit-transform:rotate(90deg);-ms-transform:rotate(90deg);transform:rotate(90deg)}.bb-dashboard-sidebar-group-title{margin:0;width:100%;border:none;display:-ms-flexbox;display:flex;cursor:pointer;text-align:left;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;-ms-flex-align:center;align-items:center;padding:17px 15px;color:rgba(0,0,0,.8);background-color:transparent;transition:color .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-group-title:focus>.bb-dashboard-sidebar-group-toggle,.bb-dashboard-sidebar-group-title:hover>.bb-dashboard-sidebar-group-toggle{opacity:1}.bb-dashboard-sidebar-group-title:active>.bb-dashboard-sidebar-group-toggle{background-color:rgba(0,0,0,.08)}.bb-dashboard-sidebar-group-icon{margin-right:15px;color:rgba(0,0,0,.25)}.bb-dashboard-sidebar-group-text{width:100%;display:block;font-size:14px;max-width:100%;overflow:hidden;font-weight:500;line-height:15px;white-space:nowrap;text-overflow:ellipsis;text-transform:uppercase}.bb-dashboard-sidebar-group-toggle{opacity:0;width:30px;height:30px;display:-ms-flexbox;display:flex;min-width:30px;min-height:30px;border-radius:50%;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;transition:opacity .2s cubic-bezier(0,0,.2,1),background-color .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-group-toggle>svg{width:16px;height:16px;fill:rgba(0,0,0,.25);-webkit-transform:rotate(90deg) rotateY(180deg);transform:rotate(90deg) rotateY(180deg);transition:transform .2s cubic-bezier(0,0,.2,1);transition:transform .2s cubic-bezier(0,0,.2,1),-webkit-transform .2s cubic-bezier(0,0,.2,1)}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboardSidebarGroup.ctorParameters = function () {
            return [
                { type: BbDashboardSidebar, decorators: [{ type: i0.Optional }, { type: i0.Host }] }
            ];
        };
        BbDashboardSidebarGroup.propDecorators = {
            isExpanded: [{ type: i0.HostBinding, args: ['class.expanded',] }],
            id: [{ type: i0.Input }],
            icon: [{ type: i0.Input }],
            title: [{ type: i0.Input }]
        };
        return BbDashboardSidebarGroup;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbDashboardSidebarItem = /** @class */ (function () {
        function BbDashboardSidebarItem(_parent) {
            this._parent = _parent;
            // Inputs.
            this.tabIndex = 0;
        }
        /**
         * @return {?}
         */
        BbDashboardSidebarItem.prototype.onClick = /**
         * @return {?}
         */
            function () {
                // Trigger the parent on item clicked call
                // so that the sidebar can be closed.
                this._parent && this._parent.onItemClicked();
            };
        Object.defineProperty(BbDashboardSidebarItem.prototype, "attributeTabIndex", {
            get: /**
             * @return {?}
             */ function () {
                // Make the items tabindex -1 so it can't
                // be tabbed to when the parent is not expanded.
                if (!this._parent.isExpanded) {
                    return -1;
                }
                // Else return the specified tabindex.
                return this.tabIndex;
            },
            enumerable: true,
            configurable: true
        });
        BbDashboardSidebarItem.decorators = [
            { type: i0.Component, args: [{
                        selector: '[bb-dashboard-sidebar-item]',
                        template: "<!--\r\n    The content between the tags will\r\n    be reflected here.\r\n-->\r\n<span class=\"bb-dashboard-sidebar-item-content\">\r\n    <ng-content>\r\n    </ng-content>\r\n</span>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-dashboard-sidebar-item',
                            '[attr.tabindex]': 'attributeTabIndex'
                        },
                        styles: [".bb-dashboard-sidebar-item{height:0;opacity:0;padding:0;display:-ms-flexbox;display:flex;line-height:0;cursor:pointer;font-size:14px;font-weight:500;margin-right:20px;-ms-flex-align:center;align-items:center;text-decoration:none;will-change:opacity,height;border-top-right-radius:16px;border-bottom-right-radius:16px;color:rgba(0,0,0,.85)!important;transition:height .2s cubic-bezier(0,0,.2,1),opacity .2s cubic-bezier(0,0,.2,1) 50ms,color .2s cubic-bezier(0,0,.2,1),background-color .2s cubic-bezier(0,0,.2,1)}.bb-dashboard-sidebar-item:focus,.bb-dashboard-sidebar-item:hover{background-color:rgba(0,0,0,.05)}.bb-dashboard-sidebar-item:active{background-color:rgba(0,0,0,.1)}.bb-dashboard-sidebar-item.active,.bb-dashboard-sidebar-item.active:active,.bb-dashboard-sidebar-item.active:focus,.bb-dashboard-sidebar-item.active:hover{color:#000;background-color:rgba(0,0,0,.15)}.bb-dashboard-sidebar-item-content{overflow:hidden;max-width:100%;white-space:nowrap;text-overflow:ellipsis}"]
                    }] }
        ];
        /** @nocollapse */
        BbDashboardSidebarItem.ctorParameters = function () {
            return [
                { type: BbDashboardSidebarGroup, decorators: [{ type: i0.Optional }] }
            ];
        };
        BbDashboardSidebarItem.propDecorators = {
            tabIndex: [{ type: i0.Input }],
            onClick: [{ type: i0.HostListener, args: ['click',] }]
        };
        return BbDashboardSidebarItem;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DECLARATIONS_EXPORTS = [
        BbDashboard,
        BbDashboardHeader,
        BbDashboardSidebar,
        BbDashboardSidebarGroup,
        BbDashboardSidebarItem
    ];
    var BbDashboardModule = /** @class */ (function () {
        function BbDashboardModule() {
        }
        BbDashboardModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: __spread(DECLARATIONS_EXPORTS),
                        exports: __spread(DECLARATIONS_EXPORTS)
                    },] }
        ];
        return BbDashboardModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var BbNotificationType = {
        Success: 'success',
        Error: 'error',
        Warning: 'warning',
        Info: 'info',
        Custom: 'custom',
    };
    var BbNotificationsConfig = /** @class */ (function () {
        function BbNotificationsConfig() {
        }
        return BbNotificationsConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var timing = '500ms';
    /** @type {?} */
    var timingFunction = timing + " cubic-bezier(0, 0, .2, 1)";
    /** @type {?} */
    var notificationAnimation = animations.trigger('notificationListAnimation', [
        animations.transition('* => *', [
            animations.query(':enter', animations.stagger(timing, [
                animations.animate(timingFunction, animations.keyframes([
                    animations.style({ height: 0, opacity: 0, transform: 'translateX(50%)', offset: 0 }),
                    animations.style({ height: '*', opacity: 0, transform: 'translateX(50%)', offset: 0.75 }),
                    animations.style({ height: '*', opacity: 1, transform: 'translateX(0)', offset: 1.0 })
                ]))
            ]), { optional: true }),
            animations.query(':leave', animations.stagger(timing, [
                animations.animate(timingFunction, animations.keyframes([
                    animations.style({ height: '*', opacity: 1, transform: 'translateX(0)', offset: 0 }),
                    animations.style({ height: '*', opacity: 0, transform: 'translateX(50%)', offset: 0.9 }),
                    animations.style({ height: 0, opacity: 0, transform: 'translateX(50%)', offset: 1.0 })
                ]))
            ]), { optional: true })
        ])
    ]);

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbNotificationsList = /** @class */ (function () {
        function BbNotificationsList() {
            // Track by function.
            this.trackByFn = function (_, item) { return item.id; };
        }
        BbNotificationsList.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-notifications-list',
                        template: "<!--\r\n    The notifications list.\r\n\r\n    The list provides the animation effect for the\r\n    incoming notifications.\r\n-->\r\n<div *ngIf=\"notifications$ | async as notifications\"\r\n     [@notificationListAnimation]=\"notifications.length\"\r\n     class=\"notifications-list-wrapper\">\r\n    <!--\r\n        The loop for the notifications.\r\n\r\n        All notifications will be displayed here. They\r\n        are wrapped within a wrapper which separates them.\r\n    -->\r\n    <div *ngFor=\"let notification of notifications; trackBy: trackByFn\"\r\n         class=\"notifications-item-wrapper\">\r\n        <bb-notifications-item [notification]=\"notification\"\r\n                               [dismissButtonText]=\"dismissText\">\r\n        </bb-notifications-item>\r\n    </div>\r\n</div>",
                        animations: [notificationAnimation],
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'class': 'bb-notifications-list',
                            'role': 'list'
                        },
                        styles: [".bb-notifications-list{top:0;right:0;bottom:0;width:100%;z-index:500;padding:10px;display:block;position:fixed;max-width:400px;pointer-events:none}.notifications-list-wrapper{width:100%;display:block;position:relative}.notifications-item-wrapper{padding:0;margin:0 0 10px;pointer-events:all}"]
                    }] }
        ];
        return BbNotificationsList;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbNotificationsItem = /** @class */ (function () {
        function BbNotificationsItem(_zone, _platform, _changeDetection) {
            var _this = this;
            this._zone = _zone;
            this._platform = _platform;
            this._changeDetection = _changeDetection;
            // Data.
            this._progress = 0;
            this._count = 0;
            // Data.
            this._radius = 19;
            this._circumference = this._radius * 2 * Math.PI;
            this.callActionAndDestroy = function (notification, action) {
                // Perform the callback (if it exists).
                action && action.callback && action.callback();
                // Call the destroy method (if it exists).
                notification && notification.destroy && notification.destroy();
            };
            this.instance = function () {
                // Calculate the difference.
                _this._difference = (new Date().getTime() - _this._startTime) - (_this._count * _this._speed);
                // Add up the count.
                if (_this._count++ === _this._steps) {
                    _this.notification.destroy();
                }
                // Add the steps to the progress.
                _this._progress += 100 / _this._steps;
                // Set a new timer.
                _this._timer = _this.setTimeout(_this.instance, _this._speed - _this._difference);
                // Run a new change detection cycle.
                _this._zone.run(function () { return _this._changeDetection.detectChanges(); });
            };
            this.setTimeout = function (method, timeout) {
                // Check if the window and method exist.
                if (!window || !window.setTimeout) {
                    return null;
                }
                return window.setTimeout(method, timeout);
            };
        }
        Object.defineProperty(BbNotificationsItem.prototype, "getClass", {
            get: /**
             * @return {?}
             */ function () {
                return "bb-notifications-item " + this.notification.type;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbNotificationsItem.prototype, "progressStrokeArray", {
            get: /**
             * @return {?}
             */ function () {
                /** @type {?} */
                var value = Math.floor(this._circumference);
                return value + ", " + value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbNotificationsItem.prototype, "progressStrokeOffset", {
            get: /**
             * @return {?}
             */ function () {
                return Math.floor(this._circumference - this._progress / 100 * this._circumference);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BbNotificationsItem.prototype, "isContentString", {
            get: /**
             * @return {?}
             */ function () {
                return typeof this.notification.content === 'string';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        BbNotificationsItem.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                // Check if the notification timeout is not 0 and the platform is a browser.
                if (this.notification.timeout <= 0 || !this._platform.isBrowser) {
                    this.notification.dismiss = true;
                    return;
                }
                // Start the timeout.
                this.startTimeout();
            };
        /**
         * @return {?}
         */
        BbNotificationsItem.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                // Clear the timeout if it was set.
                this._timer && window && window.clearTimeout && window.clearTimeout(this._timer);
            };
        /**
         * @private
         * @return {?}
         */
        BbNotificationsItem.prototype.startTimeout = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                // Calculate the steps of the timeout.
                this._steps = this.notification.timeout / 10;
                // Calculate the speed of the timeout.
                this._speed = this.notification.timeout / this._steps;
                // Get the start time.
                this._startTime = new Date().getTime();
                // Set a new timer outside of Angular.
                this._zone.runOutsideAngular(function () { return _this._timer = _this.setTimeout(_this.instance, _this._speed); });
            };
        BbNotificationsItem.decorators = [
            { type: i0.Component, args: [{
                        selector: 'bb-notifications-item',
                        template: "<div class=\"notification-content-wrapper\">\r\n    <!--\r\n        The icon for the notification.\r\n\r\n        The icon is reflected by the type of the\r\n        notification. Same goes for the color and\r\n        background-color.\r\n    -->\r\n    <div *ngIf=\"notification?.icon as icon\"\r\n         [style.color]=\"notification?.color\"\r\n         [style.background-color]=\"notification?.backgroundColor\"\r\n         class=\"notification-icon-wrapper\">\r\n        <i class=\"material-icons\">\r\n            {{ icon }}\r\n        </i>\r\n\r\n        <!--\r\n            The circular progress for the notification.\r\n\r\n            The progress is only visible when a timeout is\r\n            set. The progress adapts to the time remaining\r\n            for the notification.\r\n        -->\r\n        <svg *ngIf=\"notification?.timeout > 0\"\r\n             class=\"notification-progress-ring\"\r\n             viewBox=\"0 0 40 40\"\r\n             role=\"progressbar\">\r\n            <circle #progress\r\n                    [attr.stroke-dasharray]=\"progressStrokeArray\"\r\n                    [attr.stroke-dashoffset]=\"progressStrokeOffset\"\r\n                    [style.stroke]=\"notification?.color\"\r\n                    class=\"notification-progress-circle\"\r\n                    stroke-width=\"2\"\r\n                    fill=\"transparent\"\r\n                    r=\"19\"\r\n                    cx=\"20\"\r\n                    cy=\"20\">\r\n            </circle>\r\n        </svg>\r\n    </div>\r\n\r\n    <!--\r\n        The content for the notification.\r\n\r\n        This displays a string or a template based\r\n        on the given parameter by the user.\r\n    -->\r\n    <div class=\"notification-content\">\r\n        <ng-container *ngIf=\"isContentString; else templateContent\">\r\n            {{ notification?.content }}\r\n        </ng-container>\r\n    </div>\r\n</div>\r\n\r\n<!--\r\n    The actions of the notification.\r\n\r\n    All actions are displayed here and are\r\n    based on the actions array the user provided.\r\n-->\r\n<div *ngIf=\"notification?.actions?.length > 0 || notification?.dismiss\"\r\n     class=\"notification-actions\">\r\n    <button *ngFor=\"let action of notification?.actions\"\r\n            (click)=\"callActionAndDestroy(notification, action)\"\r\n            type=\"button\"\r\n            class=\"notification-actions-button\">\r\n        {{ action?.title }}\r\n    </button>\r\n    <button *ngIf=\"notification?.dismiss\"\r\n            (click)=\"notification?.destroy()\"\r\n            type=\"button\"\r\n            class=\"notification-actions-button\">\r\n        {{ notification?.dismissText || dismissButtonText }}\r\n    </button>\r\n</div>\r\n\r\n<!--\r\n    The outlet for the notification content template ref.\r\n-->\r\n<ng-template #templateContent>\r\n    <ng-container *ngTemplateOutlet=\"notification?.content\"></ng-container>\r\n</ng-template>",
                        changeDetection: i0.ChangeDetectionStrategy.OnPush,
                        encapsulation: i0.ViewEncapsulation.None,
                        preserveWhitespaces: false,
                        host: {
                            'role': 'alert'
                        },
                        styles: [".bb-notifications-item{display:-ms-flexbox;display:flex;border-radius:4px;-ms-flex-direction:column;flex-direction:column;background-color:#fff;border:1px solid #d6dbe0}.bb-notifications-item.success .notification-icon-wrapper{color:#36d068;background-color:#ebfaf0}.bb-notifications-item.success .notification-progress-circle{stroke:#36d068}.bb-notifications-item.error .notification-icon-wrapper{color:#f55656;background-color:#feeeee}.bb-notifications-item.error .notification-progress-circle{stroke:#f55656}.bb-notifications-item.warning .notification-icon-wrapper{color:#ffbc0b;background-color:#fff8e7}.bb-notifications-item.warning .notification-progress-circle{stroke:#ffbc0b}.bb-notifications-item.info .notification-icon-wrapper{color:#22a5f7;background-color:#e9f6fe}.bb-notifications-item.info .notification-progress-circle{stroke:#22a5f7}.bb-notifications-item.custom .notification-icon-wrapper{color:#657385;background-color:#f3f5f6}.bb-notifications-item.custom .notification-progress-circle{stroke:#657385}.notification-content-wrapper{padding:20px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center}.notification-icon-wrapper{width:40px;height:40px;display:-ms-flexbox;display:flex;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;position:relative;border-radius:50%;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;color:#657385;background-color:#f3f5f6}.notification-content{-ms-flex:1;flex:1;font-size:14px;line-height:1.5;font-weight:500;margin-left:20px;color:rgba(0,0,0,.85)}.notification-content i{font-style:italic}.notification-actions-button,.notification-content{font-family:inherit}.notification-actions{display:-ms-flexbox;display:flex;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;border-top:1px solid #f3f5f6}.notification-actions>.notification-actions-button:not(:last-child){border-right:1px solid #f3f5f6}.notification-actions-button{-ms-flex:1;flex:1;border:none;color:#22a5f7;cursor:pointer;font-size:14px;font-weight:500;padding:12px 20px;text-align:center;background-color:transparent;transition:background-color 150ms cubic-bezier(0,0,.2,1)}.notification-actions-button:hover{background-color:rgba(34,165,247,.04)}.notification-actions-button:active{text-decoration:underline;background-color:rgba(34,165,247,.08)}.notification-progress-ring{top:0;left:0;right:0;bottom:0;width:100%;height:100%;position:absolute}.notification-progress-circle{-webkit-transform:rotate(-90deg);-ms-transform:rotate(-90deg);transform:rotate(-90deg);-webkit-transform-origin:50% 50%;-ms-transform-origin:50% 50%;transform-origin:50% 50%;stroke:#657385}"]
                    }] }
        ];
        /** @nocollapse */
        BbNotificationsItem.ctorParameters = function () {
            return [
                { type: i0.NgZone },
                { type: Platform },
                { type: i0.ChangeDetectorRef }
            ];
        };
        BbNotificationsItem.propDecorators = {
            notification: [{ type: i0.Input }],
            dismissButtonText: [{ type: i0.Input }],
            progressElementRef: [{ type: i0.ViewChild, args: ['progress',] }],
            getClass: [{ type: i0.HostBinding, args: ['class',] }]
        };
        return BbNotificationsItem;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbNotificationsModule = /** @class */ (function () {
        function BbNotificationsModule(parentModule) {
            if (parentModule) {
                throw new Error('BbNotificationsModule is already loaded. Import it in the AppModule only');
            }
        }
        /**
         * @param {?=} config
         * @return {?}
         */
        BbNotificationsModule.forRoot = /**
         * @param {?=} config
         * @return {?}
         */
            function (config) {
                return {
                    ngModule: BbNotificationsModule,
                    providers: [
                        { provide: BbNotificationsConfig, useValue: config }
                    ]
                };
            };
        BbNotificationsModule.decorators = [
            { type: i0.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [BbNotificationsList, BbNotificationsItem],
                        entryComponents: [BbNotificationsList]
                    },] }
        ];
        /** @nocollapse */
        BbNotificationsModule.ctorParameters = function () {
            return [
                { type: BbNotificationsModule, decorators: [{ type: i0.Optional }, { type: i0.SkipSelf }] }
            ];
        };
        return BbNotificationsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BbNotifications = /** @class */ (function () {
        function BbNotifications(_platform, _injector, _applicationRef, _config, _componentFactoryResolver) {
            var _a;
            this._platform = _platform;
            this._injector = _injector;
            this._applicationRef = _applicationRef;
            this._config = _config;
            this._componentFactoryResolver = _componentFactoryResolver;
            // The default presets for the notification types.
            this._icons = (_a = {},
                _a[BbNotificationType.Success] = 'check',
                _a[BbNotificationType.Error] = 'notification_important',
                _a[BbNotificationType.Warning] = 'notification_important',
                _a[BbNotificationType.Info] = 'star',
                _a[BbNotificationType.Custom] = 'adb',
                _a);
            // The data containing the notifications.
            this._notifications$ = new rxjs.BehaviorSubject([]);
            this.getProperty = function (property, defaultValue) {
                return typeof property === 'undefined'
                    ? defaultValue
                    : property;
            };
            // Get the config.
            /** @type {?} */
            var config = this._config || {};
            // Set the config.
            this._defaultMode = this.getProperty(config.mode, 'prepend');
            this._defaultTimeout = this.getProperty(config.timeout, 8000);
            this._defaultDismiss = this.getProperty(config.dismiss, true);
            this._defaultDismissText = this.getProperty(config.dismissText, 'Dismiss');
            // Create the element that holds all notifications.
            this.createElement();
        }
        /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
        BbNotifications.prototype.success = /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
            function (content, actions, timeout) {
                if (actions === void 0) {
                    actions = [];
                }
                if (timeout === void 0) {
                    timeout = this._defaultTimeout;
                }
                return this.create({ content: content, timeout: timeout, actions: actions, type: BbNotificationType.Success });
            };
        /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
        BbNotifications.prototype.error = /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
            function (content, actions, timeout) {
                if (actions === void 0) {
                    actions = [];
                }
                if (timeout === void 0) {
                    timeout = this._defaultTimeout;
                }
                return this.create({ content: content, timeout: timeout, actions: actions, type: BbNotificationType.Error });
            };
        /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
        BbNotifications.prototype.warn = /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
            function (content, actions, timeout) {
                if (actions === void 0) {
                    actions = [];
                }
                if (timeout === void 0) {
                    timeout = this._defaultTimeout;
                }
                return this.create({ content: content, timeout: timeout, actions: actions, type: BbNotificationType.Warning });
            };
        /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
        BbNotifications.prototype.info = /**
         * @param {?} content
         * @param {?=} actions
         * @param {?=} timeout
         * @return {?}
         */
            function (content, actions, timeout) {
                if (actions === void 0) {
                    actions = [];
                }
                if (timeout === void 0) {
                    timeout = this._defaultTimeout;
                }
                return this.create({ content: content, timeout: timeout, actions: actions, type: BbNotificationType.Info });
            };
        /**
         * @param {?} notification
         * @return {?}
         */
        BbNotifications.prototype.create = /**
         * @param {?} notification
         * @return {?}
         */
            function (notification) {
                var _this = this;
                // Compose a new notification item.
                /** @type {?} */
                var item = this.compose(notification);
                // Add the destroy function to the notification.
                item.destroy = function () { return _this.pull(item); };
                // Add the notification to the list
                // and return the item.
                return this.push(item);
            };
        /**
         * @private
         * @param {?} notification
         * @return {?}
         */
        BbNotifications.prototype.push = /**
         * @private
         * @param {?} notification
         * @return {?}
         */
            function (notification) {
                // Get the current list.
                /** @type {?} */
                var oldList = this._notifications$.getValue();
                // Check which mode is activated.
                /** @type {?} */
                var newList = __spread(oldList);
                switch (this._defaultMode) {
                    case 'append':
                        newList = __spread(oldList, [notification]);
                        break;
                    case 'prepend':
                    default:
                        newList = __spread([notification], oldList);
                }
                // Push the new notifications.
                this._notifications$.next(newList);
                // Return the notification for further use.
                return notification;
            };
        /**
         * @private
         * @param {?} notification
         * @return {?}
         */
        BbNotifications.prototype.pull = /**
         * @private
         * @param {?} notification
         * @return {?}
         */
            function (notification) {
                // Get the current list.
                /** @type {?} */
                var newList = this._notifications$
                    .getValue()
                    .filter(function (item) { return item.id !== notification.id; });
                // Push a new list.
                this._notifications$.next(newList);
            };
        /**
         * @private
         * @param {?} notification
         * @return {?}
         */
        BbNotifications.prototype.compose = /**
         * @private
         * @param {?} notification
         * @return {?}
         */
            function (notification) {
                // Attach a random id to the notification.
                notification.id = Math.random().toString(36).substr(2, 10);
                // Set all properties.
                notification.type = this.getProperty(notification.type, BbNotificationType.Custom);
                notification.content = this.getProperty(notification.content, null);
                notification.timeout = this.getProperty(notification.timeout, this._defaultTimeout);
                notification.dismiss = this.getProperty(notification.dismiss, this._defaultDismiss);
                notification.dismissText = this.getProperty(notification.dismissText, this._defaultDismissText);
                /** @type {?} */
                var defaultIcon = this._icons[notification.type] || this._icons[BbNotificationType.Custom];
                notification.icon = this.getProperty(notification.icon, defaultIcon);
                // Return the composed notification.
                return notification;
            };
        /**
         * @private
         * @return {?}
         */
        BbNotifications.prototype.createElement = /**
         * @private
         * @return {?}
         */
            function () {
                // Create the notification list and
                // get a reference to the component.
                this._ref = this._componentFactoryResolver
                    .resolveComponentFactory(BbNotificationsList)
                    .create(this._injector);
                // Save a reference to the notifications on
                // the component.
                this._ref.instance.notifications$ = this._notifications$.pipe(operators.share());
                this._ref.instance.dismissText = this._defaultDismissText;
                // Attach the component's view to the application
                // so that the change detection will run properly.
                this._applicationRef.attachView(this._ref.hostView);
                // If the platform is not a browser return.
                if (!this._platform.isBrowser) {
                    return;
                }
                try {
                    // Append the element to the DOM.
                    document.body.appendChild(this._ref.location.nativeElement);
                }
                catch (_a) {
                    // Don't do anything, because it must've failed.
                }
            };
        BbNotifications.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: BbNotificationsModule
                    },] }
        ];
        /** @nocollapse */
        BbNotifications.ctorParameters = function () {
            return [
                { type: Platform },
                { type: i0.Injector },
                { type: i0.ApplicationRef },
                { type: BbNotificationsConfig, decorators: [{ type: i0.Optional }] },
                { type: i0.ComponentFactoryResolver }
            ];
        };
        /** @nocollapse */ BbNotifications.ngInjectableDef = i0.defineInjectable({ factory: function BbNotifications_Factory() { return new BbNotifications(i0.inject(Platform), i0.inject(i0.INJECTOR), i0.inject(i0.ApplicationRef), i0.inject(BbNotificationsConfig, 8), i0.inject(i0.ComponentFactoryResolver)); }, token: BbNotifications, providedIn: BbNotificationsModule });
        return BbNotifications;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.Platform = Platform;
    exports.Language = Language;
    exports.BbDashboard = BbDashboard;
    exports.BbDashboardHeader = BbDashboardHeader;
    exports.BbDashboardSidebar = BbDashboardSidebar;
    exports.BbDashboardSidebarGroup = BbDashboardSidebarGroup;
    exports.BbDashboardSidebarItem = BbDashboardSidebarItem;
    exports.BbDashboardModule = BbDashboardModule;
    exports.BbNotificationType = BbNotificationType;
    exports.BbNotificationsConfig = BbNotificationsConfig;
    exports.BbNotifications = BbNotifications;
    exports.BbNotificationsModule = BbNotificationsModule;
    exports.ɵc = BbNotificationsItem;
    exports.ɵa = BbNotificationsList;
    exports.ɵb = notificationAnimation;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=bravobit-bb-foundation.umd.js.map