import { TemplateRef } from '@angular/core';
export interface BbNotification {
    content: string | TemplateRef<any>;
    id?: string;
    icon?: string;
    timeout?: number;
    dismiss?: boolean;
    dismissText?: string;
    type?: BbNotificationType;
    actions?: BbNotificationAction[];
    color?: string;
    backgroundColor?: string;
    destroy?: () => void;
}
export interface BbNotificationAction {
    title: string;
    callback?: () => any;
}
export declare enum BbNotificationType {
    Success = "success",
    Error = "error",
    Warning = "warning",
    Info = "info",
    Custom = "custom"
}
export declare class BbNotificationsConfig {
    mode?: 'append' | 'prepend';
    timeout?: number;
    dismiss?: boolean;
    dismissText?: string;
}
