import { ApplicationRef, ComponentFactoryResolver, Injector, TemplateRef } from '@angular/core';
import { BbNotification, BbNotificationAction, BbNotificationsConfig } from './notifications.interfaces';
import { Platform } from '../core/services/platform.service';
export declare class BbNotifications {
    private _platform;
    private _injector;
    private _applicationRef;
    private _config;
    private _componentFactoryResolver;
    private _ref;
    private readonly _icons;
    private readonly _defaultMode;
    private readonly _defaultTimeout;
    private readonly _defaultDismiss;
    private readonly _defaultDismissText;
    private _notifications$;
    constructor(_platform: Platform, _injector: Injector, _applicationRef: ApplicationRef, _config: BbNotificationsConfig, _componentFactoryResolver: ComponentFactoryResolver);
    success(content: string | TemplateRef<any>, actions?: BbNotificationAction[], timeout?: number): BbNotification;
    error(content: string | TemplateRef<any>, actions?: BbNotificationAction[], timeout?: number): BbNotification;
    warn(content: string | TemplateRef<any>, actions?: BbNotificationAction[], timeout?: number): BbNotification;
    info(content: string | TemplateRef<any>, actions?: BbNotificationAction[], timeout?: number): BbNotification;
    create(notification: BbNotification): BbNotification;
    private push;
    private pull;
    private compose;
    private createElement;
    private getProperty;
}
